clc

baseline = 176.8;
focal = 853.38;
bf = baseline*focal;

%% Scene 3
cd 3
gt = double(imread('gt.png'));
bilateral = double(imread('interp_disp_bilateral.png'));
bilinearSeg = double(imread('interp_disp_bilinear_segmentation.png'));
iterativeBilateral = double(imread('iterative_bilateral.png'));
mask = ones(size(gt));
mask(gt==0) = 0;
mask(gt==255) = 0;
mask(bilateral==0) = 0;
mask(bilateral==255) = 0;
mask(bilinearSeg==0) = 0;
mask(bilinearSeg==255) = 0;
mask(iterativeBilateral==0) = 0;
mask(iterativeBilateral==0) = 255;
mask(:,1:277) = 0;
mask(1:202,:) = 0;
mask(:,901:size(mask,2)) = 0;
mask(566:size(mask,1),:) = 0;
bilateralMSE = gt-bilateral;
bilateralMSE = bilateralMSE.*mask;
bilateralMSE = bilateralMSE.^2;
bilateralMSE = sum(bilateralMSE(:))/sum(mask(:));
disp(['bilateralMSE scene 3 ', num2str(bilateralMSE)])
bilinearSegMSE = gt-bilinearSeg;
bilinearSegMSE = bilinearSegMSE.*mask;
bilinearSegMSE = bilinearSegMSE.^2;
bilinearSegMSE = sum(bilinearSegMSE(:))/sum(mask(:));
disp(['bilinearSegMSE scene 3 ', num2str(bilinearSegMSE)])
iterativeBilateralMSE = gt-iterativeBilateral;
iterativeBilateralMSE = iterativeBilateralMSE.*mask;
iterativeBilateralMSE = iterativeBilateralMSE.^2;
iterativeBilateralMSE = sum(iterativeBilateralMSE(:))/sum(mask(:));
disp(['iterativeBilateralMSE scene 3 ', num2str(iterativeBilateralMSE)])

bilateralABS = abs(gt-bilateral).*mask;
bilateralABS = sum(bilateralABS(:))/sum(mask(:));
disp(['bilateralABS scene 3 ', num2str(bilateralABS)])
bilinearSegABS = abs(gt-bilinearSeg).*mask;
bilinearSegABS = sum(bilinearSegABS(:))/sum(mask(:));
disp(['bilinearSegABS scene 3 ', num2str(bilinearSegABS)])
iterativeBilateralABS = abs(gt-iterativeBilateral).*mask;
iterativeBilateralABS = sum(iterativeBilateralABS(:))/sum(mask(:));
disp(['iterativeBilateralABS scene 3 ', num2str(iterativeBilateralABS)])

gt(mask==0) = 1;
bilateral(mask==0) = 1;
bilinearSeg(mask==0) = 1;
bilateral3D = abs(bf./gt-bf./bilateral).*mask;
bilateral3D = sum(bilateral3D(:))/sum(mask(:));
disp(['bilateral3D scene 3 ', num2str(bilateral3D)])
bilinearSeg3D = abs(bf./gt-bf./bilinearSeg).*mask;
bilinearSeg3D = sum(bilinearSeg3D(:))/sum(mask(:));
disp(['bilinearSeg3D scene 3 ', num2str(bilinearSeg3D)])
iterativeBilateral3D = abs(bf./gt-bf./iterativeBilateral).*mask;
iterativeBilateral3D = sum(iterativeBilateral3D(:))/sum(mask(:));
disp(['iterativeBilateral3D scene 3 ', num2str(iterativeBilateral3D)])
disp('------------------------------------------------')

cd ..

%% Scene 4
cd 4
gt = double(imread('gt.png'));
bilateral = double(imread('interp_disp_bilateral.png'));
bilinearSeg = double(imread('interp_disp_bilinear_segmentation.png'));
iterativeBilateral = double(imread('iterative_bilateral.png'));
mask = ones(size(gt));
mask(gt==0) = 0;
mask(gt==255) = 0;
mask(bilateral==0) = 0;
mask(bilateral==255) = 0;
mask(bilinearSeg==0) = 0;
mask(bilinearSeg==255) = 0;
mask(iterativeBilateral==0) = 0;
mask(iterativeBilateral==0) = 255;
mask(:,1:277) = 0;
mask(1:202,:) = 0;
mask(:,901:size(mask,2)) = 0;
mask(566:size(mask,1),:) = 0;
bilateralMSE = gt-bilateral;
bilateralMSE = bilateralMSE.*mask;
bilateralMSE = bilateralMSE.^2;
bilateralMSE = sum(bilateralMSE(:))/sum(mask(:));
disp(['bilateralMSE scene 4 ', num2str(bilateralMSE)])
bilinearSegMSE = gt-bilinearSeg;
bilinearSegMSE = bilinearSegMSE.*mask;
bilinearSegMSE = bilinearSegMSE.^2;
bilinearSegMSE = sum(bilinearSegMSE(:))/sum(mask(:));
disp(['bilinearSegMSE scene 4 ', num2str(bilinearSegMSE)])
iterativeBilateralMSE = gt-iterativeBilateral;
iterativeBilateralMSE = iterativeBilateralMSE.*mask;
iterativeBilateralMSE = iterativeBilateralMSE.^2;
iterativeBilateralMSE = sum(iterativeBilateralMSE(:))/sum(mask(:));
disp(['iterativeBilateralMSE scene 4 ', num2str(iterativeBilateralMSE)])

bilateralABS = abs(gt-bilateral).*mask;
bilateralABS = sum(bilateralABS(:))/sum(mask(:));
disp(['bilateralABS scene 4 ', num2str(bilateralABS)])
bilinearSegABS = abs(gt-bilinearSeg).*mask;
bilinearSegABS = sum(bilinearSegABS(:))/sum(mask(:));
disp(['bilinearSegABS scene 4 ', num2str(bilinearSegABS)])
iterativeBilateralABS = abs(gt-iterativeBilateral).*mask;
iterativeBilateralABS = sum(iterativeBilateralABS(:))/sum(mask(:));
disp(['iterativeBilateralABS scene 4 ', num2str(iterativeBilateralABS)])

gt(mask==0) = 1;
bilateral(mask==0) = 1;
bilinearSeg(mask==0) = 1;
bilateral3D = abs(bf./gt-bf./bilateral).*mask;
bilateral3D = sum(bilateral3D(:))/sum(mask(:));
disp(['bilateral3D scene 4 ', num2str(bilateral3D)])
bilinearSeg3D = abs(bf./gt-bf./bilinearSeg).*mask;
bilinearSeg3D = sum(bilinearSeg3D(:))/sum(mask(:));
disp(['bilinearSeg3D scene 4 ', num2str(bilinearSeg3D)])
iterativeBilateral3D = abs(bf./gt-bf./iterativeBilateral).*mask;
iterativeBilateral3D = sum(iterativeBilateral3D(:))/sum(mask(:));
disp(['iterativeBilateral3D scene 4 ', num2str(iterativeBilateral3D)])
disp('------------------------------------------------')
cd ..


%% Scene 1

cd 1
gt = double(imread('gt.png'));
bilateral = double(imread('interp_disp_bilateral.png'));
bilinearSeg = double(imread('interp_disp_bilinear_segmentation.png'));
mask = ones(size(gt));
mask(gt==0) = 0;
mask(gt==255) = 0;
mask(bilateral==0) = 0;
mask(bilateral==255) = 0;
mask(bilinearSeg==0) = 0;
mask(bilinearSeg==255) = 0;
mask(:,1:277) = 0;
mask(1:202,:) = 0;
mask(:,901:size(mask,2)) = 0;
mask(566:size(mask,1),:) = 0;
bilateralMSE = gt-bilateral;
bilateralMSE = bilateralMSE.*mask;
bilateralMSE = bilateralMSE.^2;
bilateralMSE = sum(bilateralMSE(:))/sum(mask(:));
disp(['bilateralMSE scene 1 ', num2str(bilateralMSE)])
bilinearSegMSE = gt-bilinearSeg;
bilinearSegMSE = bilinearSegMSE.*mask;
bilinearSegMSE = bilinearSegMSE.^2;
bilinearSegMSE = sum(bilinearSegMSE(:))/sum(mask(:));
disp(['bilinearSegMSE scene 1 ', num2str(bilinearSegMSE)])

bilateralABS = abs(gt-bilateral).*mask;
bilateralABS = sum(bilateralABS(:))/sum(mask(:));
disp(['bilateralABS scene 1 ', num2str(bilateralABS)])
bilinearSegABS = abs(gt-bilinearSeg).*mask;
bilinearSegABS = sum(bilinearSegABS(:))/sum(mask(:));
disp(['bilinearSegABS scene 1 ', num2str(bilinearSegABS)])

gt(mask==0) = 1;
bilateral(mask==0) = 1;
bilinearSeg(mask==0) = 1;
bilateral3D = abs(bf./gt-bf./bilateral).*mask;
bilateral3D = sum(bilateral3D(:))/sum(mask(:));
disp(['bilateral3D scene 1 ', num2str(bilateral3D)])
bilinearSeg3D = abs(bf./gt-bf./bilinearSeg).*mask;
bilinearSeg3D = sum(bilinearSeg3D(:))/sum(mask(:));
disp(['bilinearSeg3D scene 1 ', num2str(bilinearSeg3D)])
disp('------------------------------------------------')
cd ..


